/////////////////////////////////////////////////////////////////////
//
//	Applied Data Systems, Inc
//
//  SIOFunc.h : function definition for IO operations
//
//
//////////////////////////////////////////////////////////////////////

#ifndef __SIOFUNC_H__
#define __SIOFUNC_H__

#ifdef  __cplusplus
extern "C" {
#endif

UINT SIOFirmwareVersion();
UINT SIOReadDeviceVersion();
UINT SIOReadDevicePartType();

BYTE SIOReadKeypad();
BOOL SIOSetKeyPadSize(BYTE x, BYTE y);
BOOL SIOSetSpeaker(BYTE Duration, BYTE Tone);


UINT SIOAnalogConversion(BYTE channel);
UINT SIOReadVoltage();
UINT SIOReadTemperature();

void SIOSelectOption(BYTE Option);
void SIOBackLightPwm(BYTE value);
void SIOBackLightVEEPwm(BYTE value);
void SIOBackLightON();
void SIOBackLightOFF();

void SIOWritePortA(BYTE value);
void SIOWritePortB(BYTE value);
void SIOWritePortC(BYTE value);
void SIOWritePortD(BYTE value);

void SIOInitDDRA(BYTE value);
void SIOInitDDRB(BYTE value);
void SIOInitDDRC(BYTE value);
void SIOInitDDRD(BYTE value);

UINT SIOReadPortA();
UINT SIOReadPortB();
UINT SIOReadPortC();
UINT SIOReadPortD();

BOOL SIOSetSSPTimeout(ULONG Timeout);

//6/4/2001
UINT SIOReadCAN1LOW();
UINT SIOReadCAN1HI();
UINT SIOReadCAN2LOW();
UINT SIOReadCAN2HI();
UINT SIOReadDC();
UINT SIORead33V();
UINT SIOReadGNDBAT();
UINT SIOReadRADAR_IN();
UINT SIOReadIMP_IN();

#ifdef  __cplusplus
}
#endif


#endif // __SIOFUNC_H__


